---
title: Peek Queue Messages
---

[Skip to content](#_top)

[API Reference](https://developers.cloudflare.com/api/go)

[Queues](https://developers.cloudflare.com/api/go/resources/queues)

[Messages](https://developers.cloudflare.com/api/go/resources/queues/subresources/messages)

Copy Markdown

Open in **Claude**Open in **ChatGPT**Open in **Cursor**

---

**Copy Markdown****View as Markdown**

# Peek Queue Messages

client.Queues.Messages.Peek(ctx, queueID, params) (\*[MessagePeekResponse](<https://developers.cloudflare.com/api/go/resources/queues#(resource)%20queues.messages%20%3E%20(model)%20MessagePeekResponse%20%3E%20(schema)>), error)

POST/accounts/{account\_id}/queues/{queue\_id}/messages/peek

Peek messages from a Queue without leasing them. Each message includes a ref that can be passed to the purge endpoint, and remains available for subsequent peek or pull operations until it is purged.

##### Security

<details>

<summary>API Token</summary>



The preferred authorization scheme for interacting with the Cloudflare API. <a href="https://developers.cloudflare.com/fundamentals/api/get-started/create-token/">Create a token</a>.

**Example:**<code>Authorization: Bearer Sn3lZJTBX6kkg7OdcBUAxOO963GEIyGQqnFTOFYY</code>

</details>

<details>

<summary>API Email + API Key</summary>



The previous authorization scheme for interacting with the Cloudflare API, used in conjunction with a Global API key.

**Example:**<code>X-Auth-Email: user@example.com</code>

The previous authorization scheme for interacting with the Cloudflare API. When possible, use API tokens instead of Global API keys.

**Example:**<code>X-Auth-Key: 144c9defac04969c7bfad8efaa8ea194</code>

</details>

##### Accepted Permissions (at least one required)

`Queues Write``Workers Scripts Write`

##### ParametersExpand Collapse

queueID string

A Resource identifier.

maxLength32

[Link to this property](<#(resource)%20queues.messages%20%3E%20(method)%20peek%20%3E%20(params)%20default%20%3E%20(param)%20queue_id%20%3E%20(schema)>)

<details>

<summary>

params MessagePeekParams

</summary>

AccountID param.Field\[string]

Path param: A Resource identifier.

maxLength32

<a href="#(resource)%20queues.messages%20%3E%20(method)%20peek%20%3E%20(params)%20default%20%3E%20(param)%20account_id">Link to this property</a>

BatchSize param.Field\[float64]Optional

Body param: The maximum number of messages to include in a batch.

<a href="#(resource)%20queues.messages%20%3E%20(method)%20peek%20%3E%20(params)%20default%20%3E%20(param)%20batch_size">Link to this property</a>

</details>

[Link to this property](<#(resource)%20queues.messages%20%3E%20(method)%20peek%20%3E%20(params)%20default>)

##### ReturnsExpand Collapse

<details>

<summary>

type MessagePeekResponse struct{…}

</summary>

<details>

<summary>

Messages \[]MessagePeekResponseMessageOptional

</summary>

ID stringOptional

<a href="#(resource)%20queues.messages%20%3E%20(model)%20MessagePeekResponse%20%3E%20(schema)%20%3E%20(property)%20messages%20%3E%20(items)%20%3E%20(property)%20id">Link to this property</a>

Attempts float64Optional

<a href="#(resource)%20queues.messages%20%3E%20(model)%20MessagePeekResponse%20%3E%20(schema)%20%3E%20(property)%20messages%20%3E%20(items)%20%3E%20(property)%20attempts">Link to this property</a>

Body stringOptional

<a href="#(resource)%20queues.messages%20%3E%20(model)%20MessagePeekResponse%20%3E%20(schema)%20%3E%20(property)%20messages%20%3E%20(items)%20%3E%20(property)%20body">Link to this property</a>

Metadata unknownOptional

<a href="#(resource)%20queues.messages%20%3E%20(model)%20MessagePeekResponse%20%3E%20(schema)%20%3E%20(property)%20messages%20%3E%20(items)%20%3E%20(property)%20metadata">Link to this property</a>

Ref stringOptional

An opaque reference to a peeked message. You must hold on to this value and use it to purge the message.

<a href="#(resource)%20queues.messages%20%3E%20(model)%20MessagePeekResponse%20%3E%20(schema)%20%3E%20(property)%20messages%20%3E%20(items)%20%3E%20(property)%20ref">Link to this property</a>

TimestampMs float64Optional

<a href="#(resource)%20queues.messages%20%3E%20(model)%20MessagePeekResponse%20%3E%20(schema)%20%3E%20(property)%20messages%20%3E%20(items)%20%3E%20(property)%20timestamp_ms">Link to this property</a>

</details>

<a href="#(resource)%20queues.messages%20%3E%20(model)%20MessagePeekResponse%20%3E%20(schema)%20%3E%20(property)%20messages">Link to this property</a>

</details>

[Link to this property](<#(resource)%20queues.messages%20%3E%20(model)%20MessagePeekResponse%20%3E%20(schema)>)

### Peek Queue Messages

Go

HTTPTypeScriptPythonGoTerraform

```
package main

import (
  "context"
  "fmt"

  "github.com/cloudflare/cloudflare-go"
  "github.com/cloudflare/cloudflare-go/option"
  "github.com/cloudflare/cloudflare-go/queues"
)

func main() {
  client := cloudflare.NewClient(
    option.WithAPIToken("Sn3lZJTBX6kkg7OdcBUAxOO963GEIyGQqnFTOFYY"),
  )
  response, err := client.Queues.Messages.Peek(
    context.TODO(),
    "023e105f4ecef8ad9ca31a8372d0c353",
    queues.MessagePeekParams{
      AccountID: cloudflare.F("023e105f4ecef8ad9ca31a8372d0c353"),
    },
  )
  if err != nil {
    panic(err.Error())
  }
  fmt.Printf("%+v\n", response.Messages)
}
```

200 example

```
{
  "errors": [
    {
      "code": 7003,
      "message": "No route for the URI",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "messages": [
    "string"
  ],
  "result": {
    "messages": [
      {
        "id": "b01b5594f784d0165c2985833f5660dd",
        "attempts": 1,
        "body": "hello world",
        "metadata": {
          "CF-Content-Type": "text",
          "CF-sourceMessageSource": "dash"
        },
        "ref": "eyJhbGciOiJkaXIiLCJlbmMiOiJBMjU2Q0JDLUhTNTEyIn0..Q8p21d7dceR6vUfwftONdQ.JVqZgAS-Zk7MqmqccYtTHeeMElNHaOMigeWdb8LyMOg.T2_HV99CYzGaQuhTyW8RsgbnpTRZHRM6N7UoSaAKeK0",
        "timestamp_ms": 1710950954154
      }
    ]
  },
  "success": true
}
```

##### Returns Examples

200 example

```
{
  "errors": [
    {
      "code": 7003,
      "message": "No route for the URI",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "messages": [
    "string"
  ],
  "result": {
    "messages": [
      {
        "id": "b01b5594f784d0165c2985833f5660dd",
        "attempts": 1,
        "body": "hello world",
        "metadata": {
          "CF-Content-Type": "text",
          "CF-sourceMessageSource": "dash"
        },
        "ref": "eyJhbGciOiJkaXIiLCJlbmMiOiJBMjU2Q0JDLUhTNTEyIn0..Q8p21d7dceR6vUfwftONdQ.JVqZgAS-Zk7MqmqccYtTHeeMElNHaOMigeWdb8LyMOg.T2_HV99CYzGaQuhTyW8RsgbnpTRZHRM6N7UoSaAKeK0",
        "timestamp_ms": 1710950954154
      }
    ]
  },
  "success": true
}
```